package model.linearpub;

public interface StructureIterator<E> {
	
	/**
	 * Returns the next element and increments the iterator position.
	 * If iterator is at end of iteration (i.e., hasNext is false) 
	 * when called, then throws RuntimeException.
	 */	
	public E next();
	
	/**
	 * Return true if there is another element in the iteration
	 */	
	public boolean hasNext();
	
	/**
	 * Returns the next element and does NOT increment the iterator position.
	 * If iterator is at end of iteration (i.e., hasNext is false) 
	 * when called, returns null.	 * 
	 */	
	public default E peek() { return null; }

}
